/* Login ********************************************/
var HS_USER,
    HS_PW,
    HS_IP,
    HS_PORT,
    WS_OPTIONS,
    conn;
// cache jQuery selections
var $loginBtn = $('.login.button');
var $loginOverlay = $('.login.overlay');
var $connectionNotice = $('.login .connection-failed');

//add Eventlistener
$loginBtn.bind('click', evaluateForm);

// Check if Cookies are set
if (Cookies.get('user') != undefined && Cookies.get('pw') != undefined && Cookies.get('ip') != undefined && Cookies.get('port') != undefined) {
    HS_USER = Cookies.get('user');
    HS_PW = Cookies.get('pw');
    HS_IP = Cookies.get('ip');
    HS_PORT = Cookies.get('port');
    WS_OPTIONS = {host: HS_IP, port: HS_PORT};
    connectHS();
} else {
    $loginOverlay.show();
}

/**
 * Evaluation of the form
 *
 */
function evaluateForm() {
    HS_USER = $('#user').val();
    HS_PW = $('#password').val();
    HS_IP = $('#ip').val();
    HS_PORT = $('#port').val();
    //WS_OPTIONS = {host: HS_IP, HS_PORT};
    setCookies();
    connectHS();
}


/**
 * Sets cookies for login
 *
 */
function setCookies() {

    Cookies.set('user', HS_USER, {expires: 1});
    Cookies.set('pw', HS_PW, {expires: 1});
    Cookies.set('ip', HS_IP, {expires: 1});

    if (Cookies.get('port') == undefined) {
        Cookies.set('port', '443', {expires: 1});
    } else {
        Cookies.set('port', HS_PORT, {expires: 1});
    }
}

/**
 * Connect to home server
 *
 */
function connectHS() {
    // Connection to HS
    conn = HomeServerConnector.createConnection(HS_USER, HS_PW, {host: HS_IP, port: HS_PORT});

    // Is called as soon as the connection is established
    conn.onConnect = function () {
        showConnectionState(true);
        $loginOverlay.hide();
        console.log('connection established');

        //Check if Message Archive Html Element exists
        if ($('#viewMsgA').length) {
            // Request all Message Archives
            conn.select({objectKey: "MA@*", "meta": true}, function (err, result) {
                var subscribeList = [];
                for (var i = 0; i < result.length; i++) {
                    if (result[i].code == 0)
                        subscribeList.push(result[i]["key"]);
                }
                requestMessageArchives(subscribeList);
            });
        }

        // Init communication objects
        $(document).ready(function () {
            showCObject();
        });
    };

    // Is called as soon as the connection is disconnected
    conn.onDisconnect = function (code, reason, cleanly) {
        showConnectionState(false);
        document.getElementById("hs-connect").classList.add('no-connection');
        console.log('disconnected');
        Cookies.remove('user');
        Cookies.remove('pw');
        Cookies.remove('ip');
        Cookies.remove('port');
        console.log('Removed Cookies' + Cookies.get('user') + ' ' + Cookies.get('pw') + ' ' + Cookies.get('ip') + ' ' + Cookies.get('port'));
        $loginOverlay.show();
        $connectionNotice.show();
    };

    // Remove cookies on error
    function myErrorResponse(error) {
        console.log(error);
        Cookies.remove('user');
        Cookies.remove('pw');
        Cookies.remove('ip');
        Cookies.remove('port');
    }

    conn.onError = myErrorResponse;

    // Handle login
    try {
        console.log("CONNECTION STATUS:", conn.connect(true))
    } catch (e) {
        console.log(e);
        console.log("Login failed");
        Cookies.remove('user');
        Cookies.remove('pw');
        Cookies.remove('ip');
        Cookies.remove('port');
        $loginOverlay.show();
        $connectionNotice.show();
    }
}

/**
 * Set connection indicator
 *
 */
function showConnectionState(state) {
    if (state) {
        console.log('showConnectionState connected');
        var el = document.getElementById("hs-connect");
        if (el.classList.contains("no-connection"))
            el.classList.remove('no-connection');
        el.classList.add('connected');
    } else {
        var el = document.getElementById("hs-connect");
        if (el.classList.contains("connected"))
            el.classList.remove('connected');
        document.getElementById("hs-connect").classList.add('no-connection');
        console.log('showConnectionState');
        $loginOverlay.show();
        $connectionNotice.show();
        Cookies.remove('user');
        Cookies.remove('pw');
        Cookies.remove('ip');
        Cookies.remove('port');
    }
}

// Set Date
var todayDate = new Date();
var todayTime = new Date();
var dd = todayDate.getDate();
var mm = todayDate.getMonth() + 1; //January is 0!
var yyyy = todayDate.getFullYear();

(function setDate() {
    if (dd < 10) {
        dd = '0' + dd
    }

    if (mm < 10) {
        mm = '0' + mm
    }

    todayDate = dd + '.' + mm + '.' + yyyy;
    $('.today-date').html(todayDate);
})();

// Set Time
function setTime() {
    todayTime = new Date();
    var h = todayTime.getHours();
    var m = todayTime.getMinutes();

    if (m < 10) {
        m = '0' + m
    }

    todayTime = h + ":" + m;
    $('.today-time').html(todayTime);
}

window.setInterval(setTime, 1000);
