;(function( $, window, document, undefined ) {
    
    "use strict";
    
    // cache jQuery selections
    var $mainPanelTabs =  $("#main-panel-tabs"),
      $mainPanelTabActive = $("#main-panel-tabs .is-active"),
      $mainPanel = $('#main-panel'),
      $dashboard = $('#main-panel.dashboard'),
      $hotspots = $('.hotspot'),
      $floorAreas = $('.floor-area'),
      $floorPanels = $('.floor-panel .floor-summary'),
      hotsdetached,
      $controlsContainer = $('.controls');

    
    // eventListener on tab change
    $mainPanelTabs.on('change.zf.tabs', function(event){
        if(!$mainPanel.hasClass('is-open')){
            $mainPanel.foundation('open');
        }
    });
    
    // open offcanvas when active tab is clicked
    $mainPanelTabActive.click(function(){
        if(!$mainPanel.hasClass('is-open')){
            $mainPanel.foundation('open');
        }
    });
    // open offcanvas when active tab is clicked
    $('#panel2v-label').click(function(){
        if(!$mainPanel.hasClass('is-open')){
            $mainPanel.foundation('open');
        }
    });
    
    // fires when dashboard opens
    $dashboard.on('opened.zf.offcanvas', function(event){
        $hotspots.fadeOut();
        $floorAreas.fadeOut();
        $.each($floorPanels, function(index) {
            var $element = $(this);
            setTimeout(function() {
                $element.removeClass('bounceOutLeft');
                $element.addClass('bounceInLeft');
            }, 200 * (index + 1));
        });
    });
    
    // fires when dashboard close
    $dashboard.on('closed.zf.offcanvas', function(event){
        $hotspots.fadeIn();
        $floorAreas.fadeIn();
        $.each($floorPanels, function(index) {
            var $element = $(this);
            setTimeout(function() {
                $element.removeClass('bounceInLeft');
                $element.addClass('bounceOutLeft');
            }, 200 * (index + 1));
        });
    });
    
    // fires when Main panel opens
    $mainPanel.on('opened.zf.offcanvas', function(event){

        if($mainPanel.hasClass('controls-panel')){
            $('.slick-dots').hide();
            $('.slick-arrow').hide();
            $hotspots = $('.slick-active .hotspot');
            $hotspots.addClass('active').show();
            hotsdetached = $hotspots.detach();
            hotsdetached.appendTo($controlsContainer);
        }else{
            $hotspots.removeClass('active').fadeOut();
        }
        // handle Filter
        var activeFilter = $('.filter.active').data("filter");
        $hotspots.hide();
        if(activeFilter == 'all'){
            $hotspots.show();
        }else{
            $('[data-filter="'+ activeFilter +'"]').show();
        }
        checkFilterItems()
    });
    
    // fires when Main panel close
    $mainPanel.on('closed.zf.offcanvas', function(event){
        $('.hotspot').removeClass('active').fadeIn();
        $('.slick-dots').show();
        $('.slick-arrow').show();
        if($mainPanel.hasClass('controls-panel')){
            hotsdetached = $controlsContainer.find($hotspots).detach();
            hotsdetached.appendTo('.room-view .section-view.slick-active');
        }
    });

    //filter hotspots
    // cacher jQuery selections
    var $filter =  $(".filter"),
        $allHotspots = $(".hotspot"),
        $noHotspotsMsg = $('.controls .no-items');

    // add Eventlistener
    $filter.bind('click', filterItems);

    function filterItems(){
        var clickedFilter = $(this).data("filter"),
            $hotspotsFiltered = $('.controls [data-filter="'+ clickedFilter +'"]');
        $noHotspotsMsg.hide();
        $filter.removeClass('active');
        $(this).addClass('active');
        $allHotspots.hide();
        if($hotspotsFiltered.length <= 1){
            $noHotspotsMsg.show();
        }
        if(clickedFilter === 'all'){
            $hotspots.show();
            $noHotspotsMsg.hide();
        }else{
            $hotspotsFiltered.show();
        }
    }

    function checkFilterItems(){
        var $filterActive = $('.controls [data-filter].active');
        if($filterActive.hasClass('active')){
            var clickedFilter = $filterActive.data("filter"),
                $hotspotsFiltered = $('.controls [data-filter="'+ clickedFilter +'"]');
            $noHotspotsMsg.hide();
            $allHotspots.hide();
            if($hotspotsFiltered.length <= 1){
                $noHotspotsMsg.show();
            }
            if(clickedFilter === 'all'){
                $allHotspots.show();
                $noHotspotsMsg.hide();
            }else{
                $hotspotsFiltered.show();
            }
        }
    }

    
})( $, window, document );
